/* Buttons to USB MIDI Example
   USB MIDI AnalogControlChange Example
   You must select MIDI from the "Tools > USB Type" menu
*/

#include <Bounce.h>

// the MIDI channel number to send messages
const int channel = 15;

// the MIDI continuous controller for each analog input
const int controllerA9 = 11; // 11 = volume/expression

// Create Bounce objects for each button.  The Bounce object
// automatically deals with contact chatter or "bounce", and
// it makes detecting changes very simple.
Bounce button0 = Bounce(0, 15);
Bounce button1 = Bounce(1, 15);  // 15 = 15 ms debounce time
Bounce button2 = Bounce(2, 15);  // which is appropriate for good
Bounce button3 = Bounce(3, 15);  // quality mechanical pushbuttons
Bounce button4 = Bounce(4, 15);
Bounce button5 = Bounce(5, 15);  // if a button is too "sensitive"
Bounce button6 = Bounce(6, 15);  // to rapid touch, you can
Bounce button7 = Bounce(7, 15);  // increase this time.
Bounce button8 = Bounce(8, 15);
Bounce button9 = Bounce(9, 15);
Bounce button10 = Bounce(10, 15);
Bounce button11 = Bounce(11, 15);
Bounce button12 = Bounce(12, 15);
Bounce button14 = Bounce(14, 15);
Bounce button15 = Bounce(15, 15);
Bounce button16 = Bounce(16, 15);
Bounce button17 = Bounce(17, 15);
Bounce button18 = Bounce(18, 15);
Bounce button19 = Bounce(19, 15);
Bounce button20 = Bounce(20, 15);
Bounce button21 = Bounce(21, 15);
Bounce button22 = Bounce(22, 15);
Bounce button24 = Bounce(24, 15);
Bounce button25 = Bounce(25, 15);
Bounce button26 = Bounce(26, 15);
Bounce button27 = Bounce(27, 15);
Bounce button28 = Bounce(28, 15);
Bounce button29 = Bounce(29, 15);
Bounce button30 = Bounce(30, 15);
Bounce button31 = Bounce(31, 15);


void setup() {
  
  // Configure the pins for input mode with pullup resistors.
  // The pushbuttons connect from each pin to ground.  When
  // the button is pressed, the pin reads LOW because the button
  // shorts it to ground.  When released, the pin reads HIGH
  // because the pullup resistor connects to +5 volts inside
  // the chip.  LOW for "on", and HIGH for "off" may seem
  // backwards, but using the on-chip pullup resistors is very
  // convenient.  The scheme is called "active low", and it's
  // very commonly used in electronics... so much that the chip
  // has built-in pullup resistors!
  pinMode(0, INPUT_PULLUP);
  pinMode(1, INPUT_PULLUP);
  pinMode(2, INPUT_PULLUP);
  pinMode(3, INPUT_PULLUP);
  pinMode(4, INPUT_PULLUP);
  pinMode(5, INPUT_PULLUP);
  pinMode(6, INPUT_PULLUP);
  pinMode(7, INPUT_PULLUP);
  pinMode(8, INPUT_PULLUP);
  pinMode(9, INPUT_PULLUP);
  pinMode(10, INPUT_PULLUP);
  pinMode(11, INPUT_PULLUP);
  pinMode(12, INPUT_PULLUP);
  pinMode(14, INPUT_PULLUP); 
  pinMode(15, INPUT_PULLUP);
  pinMode(16, INPUT_PULLUP);
  pinMode(17, INPUT_PULLUP);
  pinMode(18, INPUT_PULLUP);
  pinMode(19, INPUT_PULLUP);
  pinMode(20, INPUT_PULLUP);
  pinMode(21, INPUT_PULLUP);
  pinMode(22, INPUT_PULLUP);
  pinMode(24, INPUT_PULLUP);
  pinMode(25, INPUT_PULLUP);
  pinMode(26, INPUT_PULLUP);
  pinMode(27, INPUT_PULLUP);
  pinMode(28, INPUT_PULLUP);
  pinMode(29, INPUT_PULLUP);
  pinMode(30, INPUT_PULLUP);
  pinMode(31, INPUT_PULLUP);
}

// store previously sent values, to detect changes
int previousA9 = -1;

elapsedMillis msec = 0;


void loop() {
  // Update all the buttons.  There should not be any long
  // delays in loop(), so this runs repetitively at a rate
  // faster than the buttons could be pressed and released.
  button0.update();
  button1.update();
  button2.update();
  button3.update();
  button4.update();
  button5.update();
  button6.update();
  button7.update();
  button8.update();
  button9.update();
  button10.update();
  button11.update();
  button12.update();
  button14.update();
  button15.update();
  button16.update();
  button17.update();
  button18.update();
  button19.update();
  button20.update();
  button21.update();
  button22.update();
  button24.update();
  button25.update();
  button26.update();
  button27.update();
  button28.update();
  button29.update();
  button30.update();
  button31.update();

  // Check each button for "falling" edge.
  // Send a MIDI Note On message when each button presses
  // Update the Joystick buttons only upon changes.
  // falling = high (not pressed - voltage from pullup resistor)
  //           to low (pressed - button connects pin to ground)
  if (button0.fallingEdge()) {
    usbMIDI.sendNoteOn(36, 99, channel);  // 36 = C2
  }
  if (button1.fallingEdge()) {
    usbMIDI.sendNoteOn(37, 99, channel);  // 37 = C#2
  }
  if (button2.fallingEdge()) {
    usbMIDI.sendNoteOn(38, 99, channel);  // 38 = D2
  }
  if (button3.fallingEdge()) {
    usbMIDI.sendNoteOn(39, 99, channel);  // 39 = D#2
  }
  if (button4.fallingEdge()) {
    usbMIDI.sendNoteOn(40, 99, channel);  // 40 = E2
  }
  if (button5.fallingEdge()) {
    usbMIDI.sendNoteOn(41, 99, channel);  // 41 = F2
  }
  if (button6.fallingEdge()) {
    usbMIDI.sendNoteOn(42, 99, channel);  // 42 = F#2
  }
  if (button7.fallingEdge()) {
    usbMIDI.sendNoteOn(43, 99, channel);  // 43 = G2
  }
  if (button8.fallingEdge()) {
    usbMIDI.sendNoteOn(44, 99, channel);  // 44 = G#2
  }
  if (button9.fallingEdge()) {
    usbMIDI.sendNoteOn(45, 99, channel);  // 45 = A2
  }
  if (button10.fallingEdge()) {
    usbMIDI.sendNoteOn(46, 99, channel);  // 46 = A#2
  }
  if (button11.fallingEdge()) {
    usbMIDI.sendNoteOn(47, 99, channel);  // 47 = B2
  }
  if (button12.fallingEdge()) {
    usbMIDI.sendNoteOn(48, 99, channel);  // 48 = C3
  }
  if (button14.fallingEdge()) {
    usbMIDI.sendNoteOn(49, 99, channel);  // 49 =C#3
  }
  if (button15.fallingEdge()) {
    usbMIDI.sendNoteOn(50, 99, channel);  // 50 = D3
  }
  if (button16.fallingEdge()) {
    usbMIDI.sendNoteOn(51, 99, channel);  // 51 = D#3
  }
  if (button17.fallingEdge()) {
    usbMIDI.sendNoteOn(52, 99, channel);  // 52 = E3
  }
  if (button18.fallingEdge()) {
    usbMIDI.sendNoteOn(53, 99, channel);  // 53 = F3
  }
  if (button19.fallingEdge()) {
    usbMIDI.sendNoteOn(54, 99, channel);  // 54 = F#3
  }
  if (button20.fallingEdge()) {
    usbMIDI.sendNoteOn(55, 99, channel);  // 55 = G3
  }
  if (button21.fallingEdge()) {
    usbMIDI.sendNoteOn(56, 99, channel);  // 56 = G#3
  }
  if (button22.fallingEdge()) {
    usbMIDI.sendNoteOn(57, 99, channel);  // 57 = A3
  }
  if (button24.fallingEdge()) {
    usbMIDI.sendNoteOn(58, 99, channel);  // 58 = A#3
  }
  if (button25.fallingEdge()) {
    usbMIDI.sendNoteOn(59, 99, channel);  // 59 = B3
  }
  if (button26.fallingEdge()) {
    usbMIDI.sendNoteOn(60, 99, channel);  // 60 = C4
  }
  if (button27.fallingEdge()) {
    usbMIDI.sendNoteOn(61, 99, channel);  // 61 = C#4
  }
  if (button28.fallingEdge()) {
    usbMIDI.sendNoteOn(62, 99, channel);  // 62 = D4
  }
  if (button29.fallingEdge()) {
    usbMIDI.sendNoteOn(63, 99, channel);  // 63 = D#4
  }
  if (button30.fallingEdge()) {
    usbMIDI.sendNoteOn(64, 99, channel);  // 64 = E4
  }
  if (button31.fallingEdge()) {
    usbMIDI.sendNoteOn(65, 99, channel);  // 65 = F4
  }

  // Check each button for "rising" edge
  // Send a MIDI Note Off message when each button releases
  // For many types of projects, you only care when the button
  // is pressed and the release isn't needed.
  // rising = low (pressed - button connects pin to ground)
  //          to high (not pressed - voltage from pullup resistor)
  if (button0.risingEdge()) {
    usbMIDI.sendNoteOff(36, 0, channel);  // 36 = C2
  }
  if (button1.risingEdge()) {
    usbMIDI.sendNoteOff(37, 0, channel);  // 37 = C#2
  }
  if (button2.risingEdge()) {
    usbMIDI.sendNoteOff(38, 0, channel);  // 38 = D2
  }
  if (button3.risingEdge()) {
    usbMIDI.sendNoteOff(39, 0, channel);  // 39 = D#2
  }
  if (button4.risingEdge()) {
    usbMIDI.sendNoteOff(40, 0, channel);  // 40 = E2
  }
  if (button5.risingEdge()) {
    usbMIDI.sendNoteOff(41, 0, channel);  // 41 = F2
  }
  if (button6.risingEdge()) {
    usbMIDI.sendNoteOff(42, 0, channel);  // 42 = F#2
  }
  if (button7.risingEdge()) {
    usbMIDI.sendNoteOff(43, 0, channel);  // 43 = G2
  }
  if (button8.risingEdge()) {
    usbMIDI.sendNoteOff(44, 0, channel);  // 44 = G#2
  }
  if (button9.risingEdge()) {
    usbMIDI.sendNoteOff(45, 0, channel);  // 45 = A2
  }
  if (button10.risingEdge()) {
    usbMIDI.sendNoteOff(46, 0, channel);  // 46 = A#2
  }
  if (button11.risingEdge()) {
    usbMIDI.sendNoteOff(47, 0, channel);  // 47 = B2
  }
  if (button12.risingEdge()) {
    usbMIDI.sendNoteOff(48, 0, channel);  // 48 = C3
  }
  if (button14.risingEdge()) {
    usbMIDI.sendNoteOff(49, 0, channel);  // 49 = C#3
  } 
  if (button15.risingEdge()) {
    usbMIDI.sendNoteOff(50, 0, channel);  // 50 = D3
  }
  if (button16.risingEdge()) {
    usbMIDI.sendNoteOff(51, 0, channel);  // 51 = D#3
  }
  if (button17.risingEdge()) {
    usbMIDI.sendNoteOff(52, 0, channel);  // 52 = E3
  }
  if (button18.risingEdge()) {
    usbMIDI.sendNoteOff(53, 0, channel);  // 53 = F3
  }
  if (button19.risingEdge()) {
    usbMIDI.sendNoteOff(54, 0, channel);  // 54 = F#3
  }
  if (button20.risingEdge()) {
    usbMIDI.sendNoteOff(55, 0, channel);  // 55 = G3
  }
  if (button21.risingEdge()) {
    usbMIDI.sendNoteOff(56, 0, channel);  // 56 = G#3
  }
  if (button22.risingEdge()) {
    usbMIDI.sendNoteOff(57, 0, channel);  // 57 = A3
  }
  if (button24.risingEdge()) {
    usbMIDI.sendNoteOff(58, 0, channel);  // 58 = A#3
  }
  if (button25.risingEdge()) {
    usbMIDI.sendNoteOff(59, 0, channel);  // 59 = B3
  }
  if (button26.risingEdge()) {
    usbMIDI.sendNoteOff(60, 0, channel);  // 60 = C4
  }
  if (button27.risingEdge()) {
    usbMIDI.sendNoteOff(61, 0, channel);  // 61 = C#4
  }
  if (button28.risingEdge()) {
    usbMIDI.sendNoteOff(62, 0, channel);  // 62 = D4
  }
  if (button29.risingEdge()) {
    usbMIDI.sendNoteOff(63, 0, channel);  // 63 = D#4
  }
  if (button30.risingEdge()) {
    usbMIDI.sendNoteOff(64, 0, channel);  // 64 = E4
  }
  if (button31.risingEdge()) {
    usbMIDI.sendNoteOff(65, 0, channel);  // 65 = F4
  }

  // MIDI Controllers should discard incoming MIDI messages.
  // http://forum.pjrc.com/threads/24179-Teensy-3-Ableton-Analog-CC-causes-midi-crash
  while (usbMIDI.read()) {
    // ignore incoming messages
  }

  // only check the analog inputs 50 times per second,
  // to prevent a flood of MIDI messages
  if (msec >= 20) {
    msec = 0;
    int n1 = analogRead(A9) / 8;
    // only transmit MIDI messages if analog input changed
    if (n1 != previousA9) {
      usbMIDI.sendControlChange(controllerA9, n1, channel);
      previousA9 = n1;
    }
  }

  // MIDI Controllers should discard incoming MIDI messages.
  // http://forum.pjrc.com/threads/24179-Teensy-3-Ableton-Analog-CC-causes-midi-crash
  while (usbMIDI.read()) {
    // ignore incoming messages
  }
}
